// uidstr.C
//
// This program is free software. See the file COPYING for details.
// Author: Mattias Engdegrd, 1997, 1998

#include <pwd.h>
#include <grp.h>
#include <sys/types.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "uidstr.h"

QIntDict<char> Uidstr::udict(101);
QIntDict<char> Uidstr::gdict(47);

// return user name (possibly numeric)

QString Uidstr::userName(int uid)
{
    char *p = udict[uid];
    if(!p) {
	struct passwd *pw = getpwuid(uid);
	if(!pw) {
	    p = (char *)malloc(11);
	    sprintf(p, "%d", uid);
	} else
	    p = strdup(pw->pw_name);
	udict.insert(uid, p);
    }
    QString s(p);
    return s;
}

// return group name (possibly numeric)

QString Uidstr::groupName(int gid)
{
    char *p = gdict[gid];
    if(!p) {
	struct group *gr = getgrgid(gid);
	if(!gr) {
	    p = (char *)malloc(11);
	    sprintf(p, "%d", gid);
	} else
	    p = strdup(gr->gr_name);
	gdict.insert(gid, p);
    }
    QString s(p);
    return s;
}

